Autocomplete
Bootstrap 5 Autocomplete component
Autocomplete component predicts the words being typed based on the first few letters given by the user. You can search the list using basic scroll and the keyboard arrows
Note: Read the API tab to find all available options and advanced customization
*
* UMD autoinits are enabled
by default. This means that you don't need to initialize
the component manually. However if you are using MDBootstrap ES format then you should pass
the required components to the initMDB method.
Basic example
The filter option is required in order for component to work properly. The option
accepts a function that is expected to return an array of results or a
Promise that resolves to an array of results.
<div id="basic" class="form-outline" data-mdb-input-init>
<input type="text" id="form11" class="form-control" />
<label class="form-label" for="form1">Example label</label>
</div>
// Initialization for ES Users
import { Input, Autocomplete, initMDB } from "mdb-ui-kit";
initMDB({ Input });
const basicAutocomplete = document.querySelector('#basic');
const data = ['One', 'Two', 'Three', 'Four', 'Five'];
const dataFilter = (value) => {
return data.filter((item) => {
return item.toLowerCase().startsWith(value.toLowerCase());
});
};
new Autocomplete(basicAutocomplete, {
filter: dataFilter
});
const basicAutocomplete = document.querySelector('#basic');
const data = ['One', 'Two', 'Three', 'Four', 'Five'];
const dataFilter = (value) => {
return data.filter((item) => {
return item.toLowerCase().startsWith(value.toLowerCase());
});
};
new mdb.Autocomplete(basicAutocomplete, {
filter: dataFilter
});
Display value
The displayValue option allow to separate oryginal result value from the value
that will be displayed in the result list or input (after selection). Its useful when the data
returned by the filter function is an array of objects. You can specify which
parameter of the object should be displayed.
<div id="displayValue" class="form-outline" data-mdb-input-init>
<input type="text" id="form13" class="form-control" />
<label class="form-label" for="form1">Example label</label>
</div>
// Initialization for ES Users
import { Input, Autocomplete, initMDB } from "mdb-ui-kit";
initMDB({ Input });
const displayValueAutocomplete = document.querySelector('#displayValue');
const data = [
{ title: 'One', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' },
{ title: 'Two', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' },
{ title: 'Three', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' },
{ title: 'Four', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' },
{ title: 'Five', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' }
];
const dataFilter = (value) => {
return data.filter((item) => {
return item.title.toLowerCase().startsWith(value.toLowerCase());
});
};
new Autocomplete(displayValueAutocomplete, {
filter: dataFilter,
displayValue: (value) => value.title,
});
const displayValueAutocomplete = document.querySelector('#displayValue');
const data = [
{ title: 'One', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' },
{ title: 'Two', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' },
{ title: 'Three', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' },
{ title: 'Four', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' },
{ title: 'Five', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' }
];
const dataFilter = (value) => {
return data.filter((item) => {
return item.title.toLowerCase().startsWith(value.toLowerCase());
});
};
new mdb.Autocomplete(displayValueAutocomplete, {
filter: dataFilter,
displayValue: (value) => value.title,
});
Asynchronous search
The function passed to the filter option can return a Promise that
resolves to an array of results. By default the component expects to receive data as an array
of strings. If you want to return an array of objects instead, you can use
displayValue option to specify which parameter should be used as a display value
of the specific result.
<div id="async" class="form-outline autocomplete" data-mdb-input-init>
<input type="text" id="form2" class="form-control" />
<label class="form-label" for="form2">Example label</label>
</div>
// Initialization for ES Users
import { Input, Autocomplete, initMDB } from "mdb-ui-kit";
initMDB({ Input });
const asyncAutocomplete = document.querySelector('#async');
const asyncFilter = async (query) => {
const url = `https://swapi.py4e.com/api/people/?search=${encodeURI(query)}`;
const response = await fetch(url);
const data = await response.json();
return data.results;
};
new Autocomplete(asyncAutocomplete, {
filter: asyncFilter,
displayValue: (value) => value.name
});
const asyncAutocomplete = document.querySelector('#async');
const asyncFilter = async (query) => {
const url = `https://swapi.py4e.com/api/people/?search=${encodeURI(query)}`;
const response = await fetch(url);
const data = await response.json();
return data.results;
};
new mdb.Autocomplete(asyncAutocomplete, {
filter: asyncFilter,
displayValue: (value) => value.name
});
Threshold
Use threshold option to specify a minimum number of the characters in the input
field needed to perform a search operation.
<div id="threshold" class="form-outline" data-mdb-input-init>
<input type="text" id="form3" class="form-control" placeholder="Type 2 characters to search" />
<label class="form-label" for="form3">Example label</label>
</div>
// Initialization for ES Users
import { Input, Autocomplete, initMDB } from "mdb-ui-kit";
initMDB({ Input });
const thresholdAutocomplete = document.querySelector('#threshold');
const data = ['One', 'Two', 'Three', 'Four', 'Five'];
const dataFilter = (value) => {
return data.filter((item) => {
return item.toLowerCase().startsWith(value.toLowerCase());
});
};
new Autocomplete(thresholdAutocomplete, {
filter: dataFilter,
threshold: 2
});
const thresholdAutocomplete = document.querySelector('#threshold');
const data = ['One', 'Two', 'Three', 'Four', 'Five'];
const dataFilter = (value) => {
return data.filter((item) => {
return item.toLowerCase().startsWith(value.toLowerCase());
});
};
new mdb.Autocomplete(thresholdAutocomplete, {
filter: dataFilter,
threshold: 2
});
Custom item template
The itemContent option allow to display custom HTML in the result list. You can
use the listHeight option to modify the result list height when you want to
display more content in the component dropdown.
<div id="customItem" class="form-outline" data-mdb-input-init data-mdb-list-height="290">
<input type="text" id="form14" class="form-control" />
<label class="form-label" for="form1">Example label</label>
</div>
// Initialization for ES Users
import { Input, Autocomplete, initMDB } from "mdb-ui-kit";
initMDB({ Input });
const customItemAutocomplete = document.querySelector('#customItem');
const data = [
{ title: 'One', subtitle: 'Secondary text' },
{ title: 'Two', subtitle: 'Secondary text' },
{ title: 'Three', subtitle: 'Secondary text' },
{ title: 'Four', subtitle: 'Secondary text' },
{ title: 'Five', subtitle: 'Secondary text' },
{ title: 'Six', subtitle: 'Secondary text' },
];
const dataFilter = (value) => {
return data.filter((item) => {
return item.title.toLowerCase().startsWith(value.toLowerCase());
});
};
new Autocomplete(customItem, {
filter: dataFilter,
displayValue: (value) => value.title,
itemContent: (result) => {
return `
<div class="autocomplete-custom-item-content">
<div class="autocomplete-custom-item-title">${result.title}</div>
<div class="autocomplete-custom-item-subtitle">${result.subtitle}</div>
</div>
`;
},
});
const customItemAutocomplete = document.querySelector('#customItem');
const data = [
{ title: 'One', subtitle: 'Secondary text' },
{ title: 'Two', subtitle: 'Secondary text' },
{ title: 'Three', subtitle: 'Secondary text' },
{ title: 'Four', subtitle: 'Secondary text' },
{ title: 'Five', subtitle: 'Secondary text' },
{ title: 'Six', subtitle: 'Secondary text' },
];
const dataFilter = (value) => {
return data.filter((item) => {
return item.title.toLowerCase().startsWith(value.toLowerCase());
});
};
new mdb.Autocomplete(customItem, {
filter: dataFilter,
displayValue: (value) => value.title,
itemContent: (result) => {
return `
<div class="autocomplete-custom-item-content">
<div class="autocomplete-custom-item-title">${result.title}</div>
<div class="autocomplete-custom-item-subtitle">${result.subtitle}</div>
</div>
`;
},
});
.autocomplete-custom-item-content {
display: flex;
flex-direction: column;
}
.autocomplete-custom-item-title {
font-weight: 500;
}
.autocomplete-custom-item-subtitle {
font-size: 0.8rem;
}
Custom content
A custom content container with a class .autocomplete-custom-content will be displayed at the
end of the autocomplete dropdown. You can use it to display a number of
search results.
<div id="customContent" class="form-outline" data-mdb-input-init>
<input type="text" id="form16" class="form-control" />
<label class="form-label" for="form1">Example label</label>
</div>
// Initialization for ES Users
import { Input, Autocomplete, initMDB } from "mdb-ui-kit";
initMDB({ Input });
const customContentAutocomplete = document.querySelector('#customContent');
const data = ['One', 'Two', 'Three', 'Four', 'Five'];
const dataFilter = (value) => {
return data.filter((item) => {
return item.toLowerCase().startsWith(value.toLowerCase());
});
};
new Autocomplete(customContent, {
filter: dataFilter,
customContent: `
<div class="autocomplete-custom-content"></div>
`,
});
customContent.addEventListener('update.mdb.autocomplete', (event) => {
const resultsLength = event.results.length;
setTimeout(() => {
customContentContainer = document.querySelector('.autocomplete-custom-content');
customContentContainer.innerHTML = `Search results: ${resultsLength}`;
}, 0);
});
const customContentAutocomplete = document.querySelector('#customContent');
const data = ['One', 'Two', 'Three', 'Four', 'Five'];
const dataFilter = (value) => {
return data.filter((item) => {
return item.toLowerCase().startsWith(value.toLowerCase());
});
};
new mdb.Autocomplete(customContent, {
filter: dataFilter,
customContent: `
<div class="autocomplete-custom-content"></div>
`,
});
customContent.addEventListener('update.mdb.autocomplete', (event) => {
const resultsLength = event.results.length;
setTimeout(() => {
customContentContainer = document.querySelector('.autocomplete-custom-content');
customContentContainer.innerHTML = `Search results: ${resultsLength}`;
}, 0);
});
.autocomplete-custom-content {
padding: 6.5px 16px;
}
Validation
The input value is automatically validated to ensure that it is a properly formatted email address.
<form class="needs-validation" novalidate style="width: 22rem;">
<div id="validation" class="form-outline" data-mdb-input-init>
<input type="text" id="form6" class="form-control" required />
<label class="form-label" for="form6">Example label</label>
<div class="valid-feedback">Looks good!</div>
<div class="invalid-feedback">Input value is required</div>
</div>
<button type="submit" id="submit" class="btn btn-primary btn-sm mt-3">
Submit
</button>
</form>
// Initialization for ES Users
import { Input, Autocomplete, initMDB } from "mdb-ui-kit";
initMDB({ Input });
const validationAutocomplete = document.querySelector('#validation');
const data = ['One', 'Two', 'Three', 'Four', 'Five'];
const dataFilter = (value) => {
return data.filter((item) => {
return item.toLowerCase().startsWith(value.toLowerCase());
});
};
new Autocomplete(validationAutocomplete, {
filter: dataFilter
});
const validationAutocomplete = document.querySelector('#validation');
const data = ['One', 'Two', 'Three', 'Four', 'Five'];
const dataFilter = (value) => {
return data.filter((item) => {
return item.toLowerCase().startsWith(value.toLowerCase());
});
};
new mdb.Autocomplete(validationAutocomplete, {
filter: dataFilter
});
Auto select
Set autoSelect option to true to enable selecting on Tab press.
<div id="auto-select" class="form-outline" data-mdb-input-init>
<input type="text" id="form1" class="form-control" />
<label class="form-label" for="form1">Example label</label>
</div>
// Initialization for ES Users
import { Input, Autocomplete, initMDB } from "mdb-ui-kit";
initMDB({ Input });
const autoSelectAutocomplete = document.querySelector('#auto-select');
const data = ['One', 'Two', 'Three', 'Four', 'Five'];
const dataFilter = (value) => {
return data.filter((item) => {
return item.toLowerCase().startsWith(value.toLowerCase());
});
};
new Autocomplete(autoSelectAutocomplete, {
filter: dataFilter,
autoSelect: true
});
const autoSelectAutocomplete = document.querySelector('#auto-select');
const data = ['One', 'Two', 'Three', 'Four', 'Five'];
const dataFilter = (value) => {
return data.filter((item) => {
return item.toLowerCase().startsWith(value.toLowerCase());
});
};
new mdb.Autocomplete(autoSelectAutocomplete, {
filter: dataFilter,
autoSelect: true
});
Autocomplete - API
Import
Importing components depends on how your application works. If you intend to use the MDBootstrap ES format, you must
first import the component and then initialize it with the initMDB method. If you are going to use the UMD format,
just import the mdb-ui-kit package.
import { Autocomplete, initMDB } from "mdb-ui-kit";
initMDB({ Autocomplete });
import "mdb-ui-kit"
Usage
Via JavaScript
const myAutocomplete = new Autocomplete(document.getElementById('myAutocomplete'), options)
const myAutocomplete = new mdb.Autocomplete(document.getElementById('myAutocomplete'), options)
Via jQuery
Note: By default, MDB does not include jQuery and you have to add it to the project on your own.
$(document).ready(() => {
$('.example-class').autocomplete(options);
});
Options
Options can be passed via data attributes or JavaScript. For data attributes, append the option name to
data-mdb-, as in data-mdb-container="body".
| Name | Type | Default | Description |
|---|---|---|---|
autoSelect
|
Boolean | false |
Enables auto selecting on Tab press |
container |
String | 'body' |
Allows to set the parent element for the autocomplete. |
customContent
|
String | '' |
Custom HTML template that will be displayed at the end of the component dropdown |
debounce
|
Number | 300 |
Delay between search queries in milliseconds, improves the component performance |
displayValue
|
Function | null | (value) => value |
Function executed for complex search results, to get value to display in the results list |
filter |
Function | null |
Function that returns filtered data to the component |
itemContent
|
Function | null | null |
Function that returns custom template for result item |
listHeight
|
Number | 190 |
Height of the result list |
noResults
|
String | 'No results found' |
Message that will be displayed in the component dropdown if no result is found |
threshold
|
Number | 0 |
Minimum input length to start search query |
Methods
| Name | Description | Example |
|---|---|---|
open |
Manually opens a component dropdown |
myAutocomplete.open()
|
close |
Manually closes a component dropdown |
myAutocomplete.close()
|
dispose
|
Disposes an autocomplete instance |
myAutocomplete.dispose()
|
getInstance
|
Static method which allows you to get the autocomplete instance associated to a DOM element. |
Autocomplete.getInstance(myAutocomplete)
|
getOrCreateInstance
|
Static method which returns the autocomplete instance associated to a DOM element or create a new one in case it wasn't initialized. |
Autocomplete.getOrCreateInstance(myAutocomplete)
|
search
|
Initialize search results for a specific value |
myAutocomplete.search('')
|
const myAutocomplete = document.getElementById('myAutocomplete');
const autocomplete = new Autocomplete(myAutocomplete);
autocomplete.open();
const myAutocomplete = document.getElementById('myAutocomplete');
const autocomplete = new mdb.Autocomplete(myAutocomplete);
autocomplete.open();
Events
| Name | Description |
|---|---|
open.mdb.autocomplete
|
This event fires immediately when the autocomplete dropdown is opened. |
close.mdb.autocomplete
|
This event fires immediately when the autocomplete dropdown is closed. |
itemSelect.mdb.autocomplete
|
This event fires immediately when the autocomplete item is selected. |
update.mdb.autocomplete
|
This event fires immediately when the autocomplete results list is updated. |
const myAutocomplete = document.getElementById('myAutocomplete')
myAutocomplete.addEventListener('open.mdb.autocomplete', (e) => {
// do something...
})
CSS variables
// .autocomplete-label
--#{$prefix}autocomplete-label-max-width: #{$autocomplete-label-max-width};
--#{$prefix}autocomplete-label-active-transform: #{$autocomplete-label-active-transform};
--#{$prefix}autocomplete-label-color: #{$autocomplete-label-color};
// .form-outline
--#{$prefix}form-outline-select-notch-border-color: #{$form-outline-select-notch-border-color};
// .autocomplete-input.focused
--#{$prefix}autocomplete-input-focused-color: #{$autocomplete-input-focused-color};
// .autocomplete-dropdown-container
--#{$prefix}autocomplete-dropdown-container-zindex: #{$autocomplete-dropdown-container-zindex};
--#{$prefix}autocomplete-dropdown-background-color: #{$autocomplete-dropdown-background-color};
--#{$prefix}autocomplete-dropdown-box-shadow: #{$autocomplete-dropdown-box-shadow};
--#{$prefix}autocomplete-dropdown-margin: #{$autocomplete-dropdown-margin};
--#{$prefix}autocomplete-dropdown-transform: #{$autocomplete-dropdown-transform};
--#{$prefix}autocomplete-dropdown-transition: #{$autocomplete-dropdown-transition};
--#{$prefix}autocomplete-dropdown-open-transform: #{$autocomplete-dropdown-open-transform};
--#{$prefix}autocomplete-item-color: #{$autocomplete-item-color};
--#{$prefix}autocomplete-item-padding: #{$autocomplete-item-padding};
--#{$prefix}autocomplete-item-font-size: #{$autocomplete-item-font-size};
--#{$prefix}autocomplete-item-font-weight: #{$autocomplete-item-font-weight};
--#{$prefix}autocomplete-item-hover-background-color: #{$autocomplete-item-hover-background-color};
--#{$prefix}autocomplete-item-disabled-color: #{$autocomplete-item-disabled-color};
--#{$prefix}autocomplete-scrollbar-thumb-background-color: #{$autocomplete-scrollbar-thumb-background-color};
SCSS variables
$autocomplete-dropdown-container-zindex: 1065;
$autocomplete-label-max-width: 80%;
$autocomplete-label-active-transform: translateY(-1rem) translateY(0.1rem) scale(0.8);
$autocomplete-input-focused-color: var(--#{$prefix}surface-color);
$autocomplete-label-color: $primary;
$autocomplete-dropdown-background-color: var(--#{$prefix}surface-bg);
$autocomplete-dropdown-box-shadow: 0 2px 5px 0 rgba(var(--#{$prefix}box-shadow-color-rgb), 0.16), 0 2px 10px 0 rgba(var(--#{$prefix}box-shadow-color-rgb), 0.12);
$autocomplete-dropdown-margin: 0;
$autocomplete-dropdown-transform: scaleY(0.8);
$autocomplete-dropdown-transition: all 0.2s;
$autocomplete-dropdown-open-transform: scaleY(1);
$autocomplete-item-color: var(--#{$prefix}surface-color);
$autocomplete-item-padding: 6.5px 16px;
$autocomplete-item-font-size: 1rem;
$autocomplete-item-font-weight: 400;
$autocomplete-item-hover-background-color: var(--#{$prefix}highlight-bg-color);
$autocomplete-item-disabled-color: rgba(var(--#{$prefix}surface-color-rgb), 0.5);
$autocomplete-scrollbar-thumb-background-color: var(--#{$prefix}scrollbar-thumb-bg);

Autocomplete

Angular Bootstrap 5 Autocomplete component

Autocomplete component predicts the words being typed based on the first few letters given by the user. You can search the list using basic scroll and the keyboard arrows.

Note: Read the API tab to find all available options and advanced customization


Basic example

        
            
            <mdb-form-control>
              <input
                mdbInput
                [ngModel]="searchText | async"
                (ngModelChange)="searchText.next($event)"
                [mdbAutocomplete]="autocomplete"
                type="text"
                id="autocomplete"
                class="form-control"
              />
              <label mdbLabel class="form-label" for="autocomplete">Example label</label>
            </mdb-form-control>
            <mdb-autocomplete #autocomplete="mdbAutocomplete">
              <mdb-option *ngFor="let option of results | async" [value]="option">
                {{ option }}
              </mdb-option>
              <div *ngIf="notFound" class="autocomplete-no-results">No results found</div>
            </mdb-autocomplete>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { Observable, Subject } from 'rxjs';
            import { map, startWith, tap } from 'rxjs/operators';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              searchText = new Subject<string>();
              results: Observable<string[]>;
              notFound = false;
              data = ['One', 'Two', 'Three', 'Four', 'Five', 'Six', 'Seven', 'Eight'];

              constructor() {
                this.results = this.searchText.pipe(
                  startWith(''),
                  map((value: string) => this.filter(value)),
                  tap((results: string[]) =>
                    results.length > 0 ? (this.notFound = false) : (this.notFound = true)
                  )
                );
              }

              filter(value: string): string[] {
                const filterValue = value.toLowerCase();
                return this.data.filter((item: string) =>
                  item.toLowerCase().includes(filterValue)
                );
              }
            }
          
        
    

Display value

The displayValue option allow to separate original result value from the value that will be displayed in the result list or input (after selection). Its useful when the data returned by the filter method is an array of objects. You can specify which parameter of the object should be displayed.

        
            
            <mdb-form-control>
              <input
                mdbInput
                [ngModel]="searchText | async"
                (ngModelChange)="searchText.next($event)"
                [mdbAutocomplete]="autocomplete"
                type="text"
                id="autocomplete"
                class="form-control"
              />
              <label mdbLabel class="form-label" for="autocomplete">Example label</label>
            </mdb-form-control>
            <mdb-autocomplete #autocomplete="mdbAutocomplete" [displayValue]="displayValue">
              <mdb-option *ngFor="let option of results | async" [value]="option">
                {{ option.title }}
              </mdb-option>
              <div *ngIf="notFound" class="autocomplete-no-results">No results found</div>
            </mdb-autocomplete>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { Observable, Subject } from 'rxjs';
            import {
              map,
              startWith,
              tap,
            } from 'rxjs/operators';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              searchText = new Subject<string>();
              results: Observable<any[]>;
              notFound = false;
              data: any[] = [
                { title: 'One', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' },
                { title: 'Two', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' },
                { title: 'Three', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' },
                { title: 'Four', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' },
                { title: 'Five', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' },
              ];

              constructor() {
                this.results = this.searchText.pipe(
                  startWith(''),
                  map((value: any) => {
                    const title = typeof value === 'string' ? value : value.title;
                    return this.filter(title)
                  }),
                  tap((results: string[]) =>
                    results.length > 0 ? (this.notFound = false) : (this.notFound = true)
                  )
                );
              }

              filter(value: string): string[] {
                const filterValue = value.toLowerCase();
                return this.data.filter((item: any) => item.title.toLowerCase().includes(filterValue));
              }

              displayValue(value: any): string {
                return value ? value.title : '';
              }
            }
          
        
    


Threshold

Use threshold option to specify a minimum number of the characters in the input field needed to perform a search operation.

        
            
            <mdb-form-control>
              <input
                mdbInput
                [ngModel]="searchText | async"
                (ngModelChange)="searchText.next($event)"
                [mdbAutocomplete]="autocomplete"
                type="text"
                id="autocomplete"
                class="form-control"
              />
              <label mdbLabel class="form-label" for="autocomplete">Example label</label>
            </mdb-form-control>
            <mdb-autocomplete #autocomplete="mdbAutocomplete">
              <mdb-option *ngFor="let option of results | async" [value]="option">
                {{ option }}
              </mdb-option>
              <div *ngIf="notFound" class="autocomplete-no-results">No results found</div>
            </mdb-autocomplete>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { Observable, of, Subject } from 'rxjs';
            import {
              map,
              mergeMap
            } from 'rxjs/operators';
            import { combineLatest } from 'rxjs'

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              searchText = new Subject<string>();
              results: Observable<string[]>;
              notFound = false;

              data = ['One', 'Two', 'Three', 'Four', 'Five', 'Six', 'Seven', 'Eight'];

              constructor() {
                this.results = this.searchText.pipe(
                  mergeMap((value: string) => {
                    const results = this.filter(value);
                      return combineLatest([of(value), of(results)]);
                  }),
                  map(([value, results]) => {
                    if (value.length > 2 && results.length === 0) {
                      this.notFound = true;
                      return results;
                    } else {
                      this.notFound = false;
                    }

                    return results;
                  })
                );
              }

              filter(value: string): string[] {
                const filterValue = value.toLowerCase();

                if (filterValue.length >= 2) {
                  return this.data.filter((item: string) => item.toLowerCase().includes(filterValue));
                } else {
                  return [];
                }
              }
            }
          
        
    

Custom item template

It is possible to customize the appearance of the autocomplete option. You can use the listHeight option to modify the result list height when you want to display more content in the component dropdown.

        
            
            <mdb-form-control>
              <input
                mdbInput
                [ngModel]="searchText | async"
                (ngModelChange)="searchText.next($event)"
                [mdbAutocomplete]="autocomplete"
                type="text"
                id="autocomplete"
                class="form-control"
              />
              <label mdbLabel class="form-label" for="autocomplete">Example label</label>
            </mdb-form-control>
            <mdb-autocomplete
              #autocomplete="mdbAutocomplete"
              [displayValue]="displayValue"
              [listHeight]="290"
              [optionHeight]="58">
                <mdb-option *ngFor="let option of results | async" [value]="option">
                  <div class="autocomplete-custom-item-content">
                    <div class="autocomplete-custom-item-title">{{ option.title }}</div>
                    <div class="autocomplete-custom-item-subtitle">{{ option.subtitle }}</div>
                  </div>
                </mdb-option>
                <div *ngIf="notFound" class="autocomplete-no-results">No results found</div>
            </mdb-autocomplete>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { Observable, Subject } from 'rxjs';
            import {
              map,
              startWith,
              tap,
            } from 'rxjs/operators';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              searchText = new Subject<string>();
              results: Observable<any[]>;
              notFound = false;
              data: any[] = [
                { title: 'One', subtitle: 'Secondary text' },
                { title: 'Two', subtitle: 'Secondary text' },
                { title: 'Three', subtitle: 'Secondary text' },
                { title: 'Four', subtitle: 'Secondary text' },
                { title: 'Five', subtitle: 'Secondary text' },
                { title: 'Six', subtitle: 'Secondary text' },
              ];

              constructor() {
                this.results = this.searchText.pipe(
                  startWith(''),
                  map((value: any) => {
                    const title = typeof value === 'string' ? value : value.title;
                    return this.filter(title)
                  }),
                  tap((results: string[]) =>
                    results.length > 0 ? (this.notFound = false) : (this.notFound = true)
                  )
                );
              }

              filter(value: string): string[] {
                const filterValue = value.toLowerCase();
                return this.data.filter((item: any) => item.title.toLowerCase().includes(filterValue));
              }

              displayValue(value: any): string {
                return value ? value.title : '';
              }
            }
          
        
    
        
            
            .autocomplete-custom-item-content {
              display: flex;
              flex-direction: column;
            }
            .autocomplete-custom-item-title {
              font-weight: 500;
            }
            .autocomplete-custom-item-subtitle {
              font-size: 0.8rem;
            }
          
        
    

Custom content

A custom content container with a class .autocomplete-custom-content will be displayed at the end of the autocomplete-custom-item-subtitle dropdown. You can use it to display a number of search results.

        
            
            <mdb-form-control>
              <input
                mdbInput
                [ngModel]="searchText | async"
                (ngModelChange)="searchText.next($event)"
                [mdbAutocomplete]="autocomplete"
                type="text"
                id="autocomplete"
                class="form-control"
              />
              <label mdbLabel class="form-label" for="autocomplete">Example label</label>
            </mdb-form-control>
            <mdb-autocomplete #autocomplete="mdbAutocomplete">
              <mdb-option *ngFor="let option of results | async" [value]="option">
                {{ option }}
              </mdb-option>
              <div *ngIf="notFound" class="autocomplete-no-results">No results found</div>
              <div class="autocomplete-custom-content">Search results: {{ customContentLength }}</div>
            </mdb-autocomplete>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { Observable, Subject } from 'rxjs';
            import {
              map,
              startWith,
              tap,
            } from 'rxjs/operators';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              searchText = new Subject<string>();
              results: Observable<string[]>;
              notFound = false;
              customContentLength: number | null = null;
              data = ['One', 'Two', 'Three', 'Four', 'Five', 'Six', 'Seven', 'Eight'];

              constructor() {
                this.results = this.searchText.pipe(
                  startWith(''),
                  map((value: string) => this.filter(value)),
                  tap((results: string[]) => {
                    results.length > 0 ? (this.notFound = false) : (this.notFound = true)
                    this.customContentLength = results.length;
                  })
                );
              }

              filter(value: string): string[] {
                const filterValue = value.toLowerCase();
                return this.data.filter((item: string) => item.toLowerCase().includes(filterValue));
              }
            }
          
        
    

Reactive forms

        
            
            <mdb-form-control>
              <input
                mdbInput
                [ngModel]="searchText | async"
                (ngModelChange)="searchText.next($event)"
                [mdbAutocomplete]="autocomplete"
                type="text"
                id="autocomplete"
                class="form-control"
              />
              <label mdbLabel class="form-label" for="autocomplete">Example label</label>
            </mdb-form-control>
            <mdb-autocomplete #autocomplete="mdbAutocomplete">
              <mdb-option *ngFor="let option of results | async" [value]="option">
                {{ option }}
              </mdb-option>
              <div *ngIf="notFound" class="autocomplete-no-results">No results found</div>
            </mdb-autocomplete>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { FormControl } from '@angular/forms';
            import { Observable } from 'rxjs';
            import {
              map,
              startWith,
              tap,
            } from 'rxjs/operators';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              reactiveControl = new FormControl();
              results: Observable<string[]>;
              notFound = false;
              data = ['One', 'Two', 'Three', 'Four', 'Five', 'Six', 'Seven', 'Eight'];

              constructor() {
                this.results = this.reactiveControl.valueChanges.pipe(
                  startWith(''),
                  map((value: string) => this.filter(value)),
                  tap((results: string[]) =>
                    results.length > 0 ? (this.notFound = false) : (this.notFound = true)
                  )
                );
              }

              filter(value: string): string[] {
                const filterValue = value.toLowerCase();
                return this.data.filter((item: string) => item.toLowerCase().includes(filterValue));
              }
            }
          
        
    

Validation

Looks good!
Input value is required
        
            
            <form [formGroup]="validationFormGroup" style="width: 22rem">
              <mdb-form-control>
                <input
                  mdbInput
                  mdbValidate
                  formControlName="validationControl"
                  [mdbAutocomplete]="autocomplete"
                  type="text"
                  id="autocomplete"
                  class="form-control"
                />
                <label mdbLabel class="form-label" for="autocomplete">Example label</label>
                <mdb-error *ngIf="input?.invalid && (input?.dirty || input?.touched)"
                  >Input value is required</mdb-error
                >
                <mdb-success *ngIf="input?.valid && (input?.dirty || input?.touched)"
                  >Looks good!</mdb-success
                >
              </mdb-form-control>
              <mdb-autocomplete #autocomplete="mdbAutocomplete">
                <mdb-option *ngFor="let option of results | async" [value]="option">
                  {{ option }}
                </mdb-option>
                <div *ngIf="notFound" class="autocomplete-no-results">No results found</div>
              </mdb-autocomplete>
              <button type="submit" id="submit" class="btn btn-primary btn-sm mt-5">Submit</button>
            </form>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { AbstractControl, FormControl, FormGroup, Validators } from '@angular/forms';
            import { Observable } from 'rxjs';
            import {
              map,
              startWith,
              tap,
            } from 'rxjs/operators';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
              styleUrls: ['./app.component.scss'],
            })
            export class AppComponent {
              validationFormGroup: FormGroup;
              results: Observable<string[]>;
              notFound = false;
              data = ['One', 'Two', 'Three', 'Four', 'Five', 'Six', 'Seven', 'Eight'];

              constructor() {
                this.validationFormGroup = new FormGroup({
                  validationControl: new FormControl('', [Validators.required]),
                });
                this.results = this.input.valueChanges.pipe(
                  startWith(''),
                  map((value: string) => this.filter(value)),
                  tap((results: string[]) =>
                    results.length > 0 ? (this.notFound = false) : (this.notFound = true)
                  )
                );
              }

              get input(): AbstractControl {
                return this.validationFormGroup.get('validationControl')!;
              }

              filter(value: string): string[] {
                const filterValue = value.toLowerCase();
                return this.data.filter((item: string) => item.toLowerCase().includes(filterValue));
              }
            }
          
        
    

PAY ONCE

USE FOREVER

Hurry up ⌛ claim exclusive long term passes available only during Cyber Weeks

Autocomplete - API


Import

        
            
        import { MdbAutocompleteModule } from 'mdb-angular-ui-kit/autocomplete';
        import { MdbFormsModule } from 'mdb-angular-ui-kit/forms';
        import { FormsModule, ReactiveFormsModule } from '@angular/forms';
          
          …
          @NgModule ({
            ...
            imports: [MdbAutocompleteModule, MdbFormsModule,FormsModule, ReactiveFormsModule],
            ...
          })
        
        
    

Inputs

Name Type Default Description
displayValue Function (value) => value Function executed for complex search results, to get value to display in the results list ue
optionHeight number 38 Changes the single option height value
listHeight number 190 Height of the results list

Outputs

Name Type Description
closed EventEmitter<void> Event emitted when the dropdown has been closed
opened EventEmitter<void> Event emitted when the dropdown has been opened
selected EventEmitter<MdbAutocompleteSelectedEvent> Event emitted when the autocomplete's item has been selected
        
            
            <mdb-form-control>
              <input
                mdbInput
                [ngModel]="searchText | async"
                (ngModelChange)="searchText.next($event)"
                [mdbAutocomplete]="autocomplete"
                type="text"
                id="autocomplete"
                class="form-control"
              />
              <label mdbLabel class="form-label" for="autocomplete">Example label</label>
            </mdb-form-control>
            <mdb-autocomplete
              #autocomplete="mdbAutocomplete"
              (opened)="onOpen()"
              (selected)="onSelected($event)"
            >
              <mdb-option *ngFor="let option of results | async" [value]="option">
                {{ option }}
              </mdb-option>
              <div *ngIf="notFound" class="autocomplete-no-results">No results found</div>
            </mdb-autocomplete>            
            
        
    
        
            
              import { Component } from '@angular/core';
              import { MdbAutocompleteSelectedEvent } from 'mdb-angular-ui-kit/autocomplete';
              import { Observable, Subject } from 'rxjs';
              import {
                map,
                startWith,
                tap,
              } from 'rxjs/operators';

              @Component({
                selector: 'app-root',
                templateUrl: './app.component.html',
                styleUrls: ['./app.component.scss'],
              })
              export class AppComponent {
                searchText = new Subject<string>();
                results: Observable<string[]>;
                notFound = false;
                data = ['One', 'Two', 'Three', 'Four', 'Five', 'Six', 'Seven', 'Eight'];

                constructor() {
                  this.results = this.searchText.pipe(
                    startWith(''),
                    map((value: string) => this.filter(value)),
                    tap((results: string[]) =>
                      results.length > 0 ? (this.notFound = false) : (this.notFound = true)
                    )
                  );
                }

                filter(value: string): string[] {
                  const filterValue = value.toLowerCase();
                  return this.data.filter((item: string) => item.toLowerCase().includes(filterValue));
                }

                onOpen(): void {
                  console.log('opened');
                }

                onSelected(event: MdbAutocompleteSelectedEvent): void {
                  console.log('selected: ', event);
                }
              }
            
        
    

Methods

Name Description Example
open Manually opens an autocomplete autocomplete.open()
close Manually closes an autocomplete autocomplete.close()
        
            
              <button class="btn btn-primary" (click)="openAutocomplete(); $event.stopPropagation()">Open autocomplete</button>
              <mdb-form-control style="width: 22rem">
                <input mdbInput [ngModel]="searchText | async" (ngModelChange)="searchText.next($event)"
                  [mdbAutocomplete]="autocomplete" type="text" id="autocomplete" class="form-control" #autocompleteInput />
                <label mdbLabel class="form-label" for="autocomplete">Example label</label>
              </mdb-form-control>
              <mdb-autocomplete #autocomplete="mdbAutocomplete">
                <mdb-option *ngFor="let option of results | async" [value]="option">
                  {{ option }}
                </mdb-option>
                <div *ngIf="notFound" class="autocomplete-no-results">No results found</div>
              </mdb-autocomplete>
            
        
    
        
            
              import { Component, ViewChild } from '@angular/core';
              import { MdbAutocompleteDirective } from 'mdb-angular-ui-kit/autocomplete';
              import { Observable, Subject } from 'rxjs';
              import { map, startWith, tap } from 'rxjs/operators';

              @Component({
                selector: 'app-root',
                templateUrl: './app.component.html',
                styleUrls: ['./app.component.scss'],
              })
              export class AppComponent {
                searchText = new Subject<string>();
                results: Observable<string[]>;
                notFound = false;
                data = ['One', 'Two', 'Three', 'Four', 'Five', 'Six', 'Seven', 'Eight'];

                @ViewChild('autocompleteInput', { read: MdbAutocompleteDirective }) autocomplete!: MdbAutocompleteDirective;

                constructor() {
                  this.results = this.searchText.pipe(
                    startWith(''),
                    map((value: string) => this.filter(value)),
                    tap((results: string[]) =>
                      results.length > 0 ? (this.notFound = false) : (this.notFound = true)
                    )
                  );
                }

                filter(value: string): string[] {
                  const filterValue = value.toLowerCase();
                  return this.data.filter((item: string) => item.toLowerCase().includes(filterValue));
                }

                openAutocomplete(): void {
                  this.autocomplete.open();
                }
              }
            
        
    

Advanced types

MdbAutocompleteSelectedEvent

        
            
          interface MdbAutocompleteSelectedEvent {
            component: MdbAutocompleteComponent;
            option: MdbOptionComponent;
          }
          
        
    

CSS variables

        
            
          --#{$prefix}autocomplete-label-active-transform: #{$autocomplete-label-active-transform};
          --#{$prefix}autocomplete-label-color: #{$autocomplete-label-color};

          --#{$prefix}form-outline-select-notch-border-color: #{$form-outline-select-notch-border-color};

          --#{$prefix}autocomplete-input-focused-color: #{$autocomplete-input-focused-color};

          --#{$prefix}autocomplete-dropdown-container-zindex: #{$autocomplete-dropdown-container-zindex};
          --#{$prefix}autocomplete-dropdown-background-color: #{$autocomplete-dropdown-background-color};
          --#{$prefix}autocomplete-dropdown-box-shadow: #{$autocomplete-dropdown-box-shadow};
          --#{$prefix}autocomplete-dropdown-margin: #{$autocomplete-dropdown-margin};
          --#{$prefix}autocomplete-dropdown-transform: #{$autocomplete-dropdown-transform};
          --#{$prefix}autocomplete-dropdown-transition: #{$autocomplete-dropdown-transition};
          --#{$prefix}autocomplete-dropdown-open-transform: #{$autocomplete-dropdown-open-transform};
          --#{$prefix}autocomplete-item-color: #{$autocomplete-item-color};
          --#{$prefix}autocomplete-item-padding: #{$autocomplete-item-padding};
          --#{$prefix}autocomplete-item-font-size: #{$autocomplete-item-font-size};
          --#{$prefix}autocomplete-item-font-weight: #{$autocomplete-item-font-weight};
          --#{$prefix}autocomplete-item-hover-background-color: #{$autocomplete-item-hover-background-color};
          --#{$prefix}autocomplete-item-disabled-color: #{$autocomplete-item-disabled-color};
        
        
    

SCSS variables

        
            
        $autocomplete-dropdown-container-zindex: 1065;

        $autocomplete-label-max-width: 80%;
        $autocomplete-label-active-transform: translateY(-1rem) translateY(0.1rem) scale(0.8);
        $autocomplete-input-focused-color: #616161;
        $autocomplete-label-color: $primary;
        $autocomplete-dropdown-background-color: #fff;
        $autocomplete-dropdown-box-shadow: 0 2px 5px 0 rgba(0, 0, 0, 0.16), 0 2px 10px 0 rgba(0, 0, 0, 0.12);
        $autocomplete-dropdown-margin: 0;
        $autocomplete-dropdown-transform: scaleY(0.8);
        $autocomplete-dropdown-transition: all 0.2s;
        $autocomplete-dropdown-open-transform: scaleY(1);
        $autocomplete-item-color: rgba(0, 0, 0, 0.87);
        $autocomplete-item-padding: 6.5px 16px;
        $autocomplete-item-font-size: 1rem;
        $autocomplete-item-font-weight: 400;
        $autocomplete-item-hover-background-color: #ddd;
        $autocomplete-item-disabled-color: #9e9e9e;

Autocomplete

React Bootstrap 5 Autocomplete component

Autocomplete component predicts the words being typed based on the first few letters given by the user. You can search the list using basic scroll and the keyboard arrows

Note: Read the API tab to find all available options and advanced customization


Basic example

The dataFilter property is required in order for component to work properly. The option accepts a function that is expected to return an array of results or a Promise that resolves to an array of results.

        
            
            import React, { useState } from 'react';
            import { MDBAutocomplete } from 'mdb-react-ui-kit';

            const defaultData = ['One', 'Two', 'Three', 'Four', 'Five', 'Six', 'Seven', 'Eight'];
      
            export default function App() {
              const [data, setData] = useState(defaultData);

              const onSearch = (value: string) =>
                setData(defaultData.filter((item) => item.toLowerCase().startsWith(value.toLowerCase())));

              return (
                <MDBAutocomplete data={data} label='Example label' onSearch={onSearch} />
              );
            }
          
        
    

Controlled value

The value property allows to control the value of the input. Add a handler to the onChange event to update the outer state.

        
            
            import React, { useState } from 'react';
            import { MDBAutocomplete } from 'mdb-react-ui-kit';

            const defaultData = ['One', 'Two', 'Three', 'Four', 'Five', 'Six', 'Seven', 'Eight'];

            export default function App() {
              const [data, setData] = useState(defaultData);
              const [value, setValue] = useState('');

              const onSearch = (value: string) =>
                setData(defaultData.filter((item) => item.toLowerCase().startsWith(value.toLowerCase())));

              return (
                <MDBAutocomplete
                  data={data}
                  label='Example label'
                  onSearch={onSearch}
                  value={value}
                  onChange={(value) => setValue(value)}
                />
              );
            }
          
        
    

Controlled open state

The open property allows to control the visibility of the result list.

        
            
            import React, { useState } from 'react';
            import { MDBAutocomplete } from 'mdb-react-ui-kit';

            const defaultData = ['One', 'Two', 'Three', 'Four', 'Five', 'Six', 'Seven', 'Eight'];

            export default function App() {
              const [open, setOpen] = useState(false);
              const [data, setData] = useState(defaultData);

              const onSearch = (value: string) =>
                setData(defaultData.filter((item) => item.toLowerCase().startsWith(value.toLowerCase())));

              const handleOpen = () => setOpen(true);
              const handleClose = () => setOpen(false);

              return (
                <MDBAutocomplete
                  data={data}
                  label='Example label'
                  onSearch={onSearch}
                  open={open}
                  onOpen={handleOpen}
                  onClose={handleClose}
                />
              );
            }
          
        
    

Display value

The displayValue property allow to separate oryginal result value from the value that will be displayed in the result list or input (after selection). Its useful when the data returned by the dataFilter function is an array of objects. You can specify which parameter of the object should be displayed.

        
            
            import React, { useState } from 'react';
            import { MDBAutocomplete } from 'mdb-react-ui-kit';

            const defaultAdvanced = [
              { title: 'One', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' },
              { title: 'Two', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' },
              { title: 'Three', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' },
              { title: 'Four', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' },
              { title: 'Five', description: 'Lorem ipsum dolor sit, amet consectetur adipisicing elit' },
            ];
      
            export default function App() {
              const [advancedData, setAdvancedData] = useState(defaultAdvanced);

              const onAdvancedSearch = (value: string) =>
                setAdvancedData(defaultAdvanced.filter((item) => item.title.toLowerCase().startsWith(value.toLowerCase())));

              return (
                <MDBAutocomplete
                  data={advancedData}
                  label='Example label'
                  displayValue={(row) => row.title}
                  onSearch={onAdvancedSearch}
                />
              );
            }
          
        
    


Threshold

Use threshold property to specify a minimum number of the characters in the input field needed to perform a search operation.

        
            
            import React, { useState } from 'react';
            import { MDBAutocomplete } from 'mdb-react-ui-kit';

            const defaultData = ['One', 'Two', 'Three', 'Four', 'Five', 'Six', 'Seven', 'Eight'];
      
            export default function App() {
              const [thresholdData, setThresholdData] = useState(defaultData);

              const onThresholdSearch = (value: string) =>
              value.length > 1
                ? setThresholdData(defaultData.filter((item) => item.toLowerCase().startsWith(value.toLowerCase())))
                : setThresholdData([]);

              return (
                <MDBAutocomplete data={thresholdData} label='Example label' onSearch={onThresholdSearch} />
              );
            }
          
        
    

Custom item template

The itemContent property allow to display custom HTML in the result list.

        
            
            import React, { useState } from 'react';
            import { MDBAutocomplete } from 'mdb-react-ui-kit';

            const customDefData = [
              { title: 'One', subtitle: 'Secondary text' },
              { title: 'Two', subtitle: 'Secondary text' },
              { title: 'Three', subtitle: 'Secondary text' },
              { title: 'Four', subtitle: 'Secondary text' },
              { title: 'Five', subtitle: 'Secondary text' },
              { title: 'Six', subtitle: 'Secondary text' },
            ];
      
            export default function App() {
              const [customData, setCustomData] = useState(customDefData);

              const onCustomSearch = (value: string) =>
                setCustomData(customDefData.filter((item) => item.title.toLowerCase().startsWith(value.toLowerCase())));

              return (
                <MDBAutocomplete
                  data={customData}
                  label='Example label'
                  displayValue={(row) => row.title}
                  onSearch={onCustomSearch}
                  itemContent={(result) => (
                    <div className='autocomplete-custom-item-content'>
                      <div className='autocomplete-custom-item-title'>{result.title}</div>
                      <div className='autocomplete-custom-item-subtitle'>{result.subtitle}</div>
                    </div>
                  )}
                />
              );
            }
          
        
    
        
            
            .autocomplete-custom-item-content {
              display: flex;
              flex-direction: column;
            }

            .autocomplete-custom-item-title {
              font-weight: 500;
            }

            .autocomplete-custom-item-subtitle {
              font-size: 0.8rem;
            }
          
        
    

Custom content

A custom content container with a class .autocomplete-custom-content will be displayed at the end of the autocomplete-custom-item-subtitle dropdown. You can use it to display a number of search results.

        
            
            import React, { useState } from 'react';
            import { MDBAutocomplete } from 'mdb-react-ui-kit';

            
            const defaultData = ['One', 'Two', 'Three', 'Four', 'Five', 'Six', 'Seven', 'Eight'];
      
            export default function App() {
              const [contentData, setContentData] = useState(defaultData);

              const onContentSearch = (value: string) =>
                setContentData(defaultData.filter((item) => item.toLowerCase().startsWith(value.toLowerCase())));

              return (
                <MDBAutocomplete
                  data={contentData}
                  label='Example label'
                  onSearch={onContentSearch}
                  customContent={<div className='autocomplete-custom-content'>Search results: {contentData.length}</div>}
                />
              );
            }
          
        
    
        
            
            .autocomplete-custom-content {
              padding: 6.5px 16px;
            }
          
        
    

Validation

Looks good!
Input value is required
        
            
            import React, { useState } from 'react';
            import { MDBAutocomplete, MDBValidation, MDBValidationItem, MDBBtn } from 'mdb-react-ui-kit';
      
            const defaultData = ['One', 'Two', 'Three', 'Four', 'Five', 'Six', 'Seven', 'Eight'];

            export default function App() {
              const [data, setData] = useState(defaultData);

              const onSearch = (value: string) =>
                setData(defaultData.filter((item) => item.toLowerCase().startsWith(value.toLowerCase())));

              return (
                <MDBValidation>
                  <MDBValidationItem>
                     <MDBAutocomplete data={data} label='Example label' onSearch={onSearch} />
                  </MDBValidationItem>
    
                  <MDBBtn size='sm' className='mt-3' type='submit'>
                    Submit
                  </MDBBtn>
                </MDBValidation>
              );
            }
          
        
    

24H 00M 00S

Get one of the limited daily offers for AI Bundles with 98% OFF for our Black Days Sale!

Autocomplete - API


Import

        
            
        import { MDBAutocomplete } from 'mdb-react-ui-kit';
        
        
    

Properties

MDBAutocomplete

Name Type Default Description Example
autoSelect boolean false Enables auto selecting on Tab press <MDBAutocomplete autoSelect />
customContent ReactNode - Custom HTML template that will be displayed at the end of the component dropdown <MDBAutocomplete customContent={element} />
data string[] | Record[] [] Autocomplete data state <MDBAutocomplete data={defaultData} />
listHeight string '190px' The autcomplete list height <MDBAutocomplete listHeight="200px" />
isLoading boolean false Enables input spinner <MDBAutocomplete isLoading={isLoading} />
open boolean - Enables controlling the open state <MDBAutocomplete open={true} />
noResults string 'No results found' Text displayed with no matching results <MDBAutocomplete noResults='-' />
ref React.Ref undefined Reference to the input element <MDBInput ref={inputReference} />

Events

Name Type Description
displayValue (row: Record) => any Function executed for complex search results, to get value to display in the results list
itemContent (value: Record) => ReactNode Function that returns custom template for result item
onClose () => void Callback fired when the component requests to be closed
onClosed () => void Executed when closing transition is over
onOpen () => void Callback fired when the component requests to be opened
onOpened () => void Executed when opening transition is over
onSelect (itemData: string | Record) => void Executed when option selected
onSearch (data: string) => void Executed when the autocomplete value changes

CSS variables

        
            
          --#{$prefix}autocomplete-label-max-width: #{$autocomplete-label-max-width};
          --#{$prefix}autocomplete-label-active-transform: #{$autocomplete-label-active-transform};
          --#{$prefix}autocomplete-label-color: #{$autocomplete-label-color};

          --#{$prefix}form-outline-select-notch-border-color: #{$form-outline-select-notch-border-color};

          --#{$prefix}autocomplete-input-focused-color: #{$autocomplete-input-focused-color};

          --#{$prefix}autocomplete-dropdown-container-zindex: #{$autocomplete-dropdown-container-zindex};
          --#{$prefix}autocomplete-dropdown-background-color: #{$autocomplete-dropdown-background-color};
          --#{$prefix}autocomplete-dropdown-box-shadow: #{$autocomplete-dropdown-box-shadow};
          --#{$prefix}autocomplete-dropdown-margin: #{$autocomplete-dropdown-margin};
          --#{$prefix}autocomplete-dropdown-transform: #{$autocomplete-dropdown-transform};
          --#{$prefix}autocomplete-dropdown-transition: #{$autocomplete-dropdown-transition};
          --#{$prefix}autocomplete-dropdown-open-transform: #{$autocomplete-dropdown-open-transform};
          --#{$prefix}autocomplete-item-color: #{$autocomplete-item-color};
          --#{$prefix}autocomplete-item-padding: #{$autocomplete-item-padding};
          --#{$prefix}autocomplete-item-font-size: #{$autocomplete-item-font-size};
          --#{$prefix}autocomplete-item-font-weight: #{$autocomplete-item-font-weight};
          --#{$prefix}autocomplete-item-hover-background-color: #{$autocomplete-item-hover-background-color};
          --#{$prefix}autocomplete-item-disabled-color: #{$autocomplete-item-disabled-color};
        
        
    

SCSS variables

        
            
        $autocomplete-dropdown-container-zindex: 1065;

        $autocomplete-label-max-width: 80%;
        $autocomplete-label-active-transform: translateY(-1rem) translateY(0.1rem) scale(0.8);
        $autocomplete-input-focused-color: #616161;
        $autocomplete-label-color: $primary;
        $autocomplete-dropdown-background-color: #fff;
        $autocomplete-dropdown-box-shadow: 0 2px 5px 0 rgba(0, 0, 0, 0.16), 0 2px 10px 0 rgba(0, 0, 0, 0.12);
        $autocomplete-dropdown-margin: 0;
        $autocomplete-dropdown-transform: scaleY(0.8);
        $autocomplete-dropdown-transition: all 0.2s;
        $autocomplete-dropdown-open-transform: scaleY(1);
        $autocomplete-item-color: rgba(0, 0, 0, 0.87);
        $autocomplete-item-padding: 6.5px 16px;
        $autocomplete-item-font-size: 1rem;
        $autocomplete-item-font-weight: 400;
        $autocomplete-item-hover-background-color: #ddd;
        $autocomplete-item-disabled-color: #9e9e9e;

Autocomplete

Vue Bootstrap 5 Autocomplete component

Autocomplete component predicts the words being typed based on the first few letters given by the user. You can search the list using basic scroll and the keyboard arrows

Note: Read the API tab to find all available options and advanced customization


Basic example

The filter property is required in order for component to work properly. The property accepts a function that is expected to return an array of results or a Promise that resolves to an array of results.

        
            
            <template>
              <MDBAutocomplete
                v-model="autocompleteBasic"
                :filter="filterBasic"
                label="Example label"
              />
            </template>
          
        
    
        
            
            <script>
              import { MDBAutocomplete } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              export default {
                components: {
                  MDBAutocomplete
                },
                setup() {
                  const autocompleteBasic = ref("");
                  const optionsBasic = ref([
                    "One",
                    "Two",
                    "Three",
                    "Four",
                    "Five",
                    "Six",
                    "Seven",
                    "Eight"
                  ]);
                  const filterBasic = value => {
                    return optionsBasic.value.filter(item => {
                      return item.toLowerCase().startsWith(value.toLowerCase());
                    });
                  };

                  return {
                    autocompleteBasic,
                    filterBasic
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBAutocomplete } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const autocompleteBasic = ref("");
              const optionsBasic = ref([
                "One",
                "Two",
                "Three",
                "Four",
                "Five",
                "Six",
                "Seven",
                "Eight"
              ]);
              const filterBasic = (value: string) => {
                return optionsBasic.value.filter((item: string) => {
                  return item.toLowerCase().startsWith(value.toLowerCase());
                });
              };
            </script>
          
        
    

Display value

The displayValue property allow to separate original result value from the value that will be displayed in the result list or input (after selection). Its useful when the data returned by the filter function is an array of objects. You can specify which parameter of the object should be displayed.

        
            
            <template>
              <MDBAutocomplete
                v-model="autocompleteDisplay"
                :filter="filterDisplay"
                :displayValue="displayValueDisplay"
                label="Example label"
              />
            </template>
          
        
    
        
            
            <script>
              import { MDBAutocomplete } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              export default {
                components: {
                  MDBAutocomplete
                },
                setup() {
                  const autocompleteDisplay = ref("");
                  const optionsDisplay = ref([
                    { title: "One", subtitle: "Secondary text" },
                    { title: "Two", subtitle: "Secondary text" },
                    { title: "Three", subtitle: "Secondary text" },
                    { title: "Four", subtitle: "Secondary text" },
                    { title: "Five", subtitle: "Secondary text" },
                    { title: "Six", subtitle: "Secondary text" }
                  ]);
                  const filterDisplay = value => {
                    return optionsDisplay.value.filter(item => {
                      return item.title.toLowerCase().startsWith(value.toLowerCase());
                    });
                  };
                  const displayValueDisplay = value => value.title;

                  return {
                    autocompleteDisplay,
                    filterDisplay,
                    displayValueDisplay
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBAutocomplete } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              interface Option {
                title: string;
                subtitle: string;
              }

              const autocompleteDisplay = ref("");
              const optionsDisplay = ref([
                { title: "One", subtitle: "Secondary text" },
                { title: "Two", subtitle: "Secondary text" },
                { title: "Three", subtitle: "Secondary text" },
                { title: "Four", subtitle: "Secondary text" },
                { title: "Five", subtitle: "Secondary text" },
                { title: "Six", subtitle: "Secondary text" }
              ]);
              const filterDisplay = (value: string) => {
                return optionsDisplay.value.filter((item: Option) => {
                  return item.title.toLowerCase().startsWith(value.toLowerCase());
                });
              };
              const displayValueDisplay = (value: Option) => value.title;
            </script>
          
        
    


Threshold

Use threshold property to specify a minimum number of the characters in the input field needed to perform a search operation.

        
            
            <template>
              <MDBAutocomplete
                v-model="autocompleteThreshold"
                :filter="filterThreshold"
                :threshold="2"
                label="Example label"
                placeholder="Type 2 characters to search"
              />
            </template>
          
        
    
        
            
            <script>
              import { MDBAutocomplete } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              export default {
                components: {
                  MDBAutocomplete
                },
                setup() {
                  const autocompleteThreshold = ref("");
                  const optionsThreshold = ref([
                    "One",
                    "Two",
                    "Three",
                    "Four",
                    "Five",
                    "Six",
                    "Seven",
                    "Eight"
                  ]);
                  const filterThreshold = value => {
                    return optionsThreshold.value.filter(item => {
                      return item.toLowerCase().startsWith(value.toLowerCase());
                    });
                  };

                  return {
                    autocompleteThreshold,
                    filterThreshold
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBAutocomplete } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const autocompleteThreshold = ref("");
              const optionsThreshold = ref([
                "One",
                "Two",
                "Three",
                "Four",
                "Five",
                "Six",
                "Seven",
                "Eight"
              ]);
              const filterThreshold = (value: string) => {
                return optionsThreshold.value.filter((item: string) => {
                  return item.toLowerCase().startsWith(value.toLowerCase());
                });
              };
            </script>
          
        
    

Custom item template

The itemContent property allow to display custom HTML in the result list. You can use the optionHeight and visibleOptions properties to modify the result list height when you want to display more content in the component dropdown.

        
            
            <template>
              <MDBAutocomplete
                v-model="autocompleteTemplate"
                :filter="filterTemplate"
                :displayValue="displayValueTemplate"
                :itemContent="itemTemplate"
                label="Example label"
              />
            </template>
          
        
    
        
            
            <script>
              import { MDBAutocomplete } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              export default {
                components: {
                  MDBAutocomplete
                },
                setup() {
                  const autocompleteTemplate = ref("");
                  const optionsTemplate = ref([
                    { title: "One", subtitle: "Secondary text" },
                    { title: "Two", subtitle: "Secondary text" },
                    { title: "Three", subtitle: "Secondary text" },
                    { title: "Four", subtitle: "Secondary text" },
                    { title: "Five", subtitle: "Secondary text" },
                    { title: "Six", subtitle: "Secondary text" }
                  ]);
                  const itemTemplate = result => {
                    return `
                      <div class="autocomplete-custom-item-content">
                        <div class="autocomplete-custom-item-title">${result.title}</div>
                        <div class="autocomplete-custom-item-subtitle">${result.subtitle}</div>
                      </div>
                    `;
                  };
                  const filterTemplate = value => {
                    return optionsTemplate.value.filter(item => {
                      return item.title.toLowerCase().startsWith(value.toLowerCase());
                    });
                  };
                  const displayValueTemplate = value => value.title;

                  return {
                    autocompleteTemplate,
                    filterTemplate,
                    itemTemplate,
                    displayValueTemplate
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBAutocomplete } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              interface Option {
                title: string;
                subtitle: string;
              }

              const autocompleteTemplate = ref("");
              const optionsTemplate = ref([
                { title: "One", subtitle: "Secondary text" },
                { title: "Two", subtitle: "Secondary text" },
                { title: "Three", subtitle: "Secondary text" },
                { title: "Four", subtitle: "Secondary text" },
                { title: "Five", subtitle: "Secondary text" },
                { title: "Six", subtitle: "Secondary text" }
              ]);
              const itemTemplate = (result: Option) => {
                return `
                  <div class="autocomplete-custom-item-content">
                    <div class="autocomplete-custom-item-title">${result.title}</div>
                    <div class="autocomplete-custom-item-subtitle">${result.subtitle}</div>
                  </div>
                `;
              };
              const filterTemplate = (value: string) => {
                return optionsTemplate.value.filter((item: Option) => {
                  return item.title.toLowerCase().startsWith(value.toLowerCase());
                });
              };
              const displayValueTemplate = (value: Option) => value.title;
            </script>
          
        
    

Custom content

Pass any content to a default slot to display a custom content container with a class .autocomplete-custom-content at the end of the items list. You can use it to display a number of search results.

        
            
            <template>
              <MDBAutocomplete
                v-model="autocompleteContent"
                :filter="filterContent"
                @update="setResultsLength"
                label="Example label"
              >
                Search results: {{ contentResultsLength }}
              </MDBAutocomplete>
            </template>
          
        
    
        
            
            <script>
              import { MDBAutocomplete } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              export default {
                components: {
                  MDBAutocomplete
                },
                setup() {
                  const autocompleteContent = ref("");
                  const optionsContent = ref([
                    "One",
                    "Two",
                    "Three",
                    "Four",
                    "Five",
                    "Six",
                    "Seven",
                    "Eight"
                  ]);
                  const contentResultsLength = ref(0);
                  const setResultsLength = event => {
                    contentResultsLength.value = event.length;
                  };
                  const filterContent = value => {
                    return optionsContent.value.filter(item => {
                      return item.toLowerCase().startsWith(value.toLowerCase());
                    });
                  };

                  return {
                    autocompleteContent,
                    contentResultsLength,
                    setResultsLength,
                    filterContent
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBAutocomplete } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const autocompleteContent = ref("");
              const optionsContent = ref([
                "One",
                "Two",
                "Three",
                "Four",
                "Five",
                "Six",
                "Seven",
                "Eight"
              ]);
              const contentResultsLength = ref(0);
              const setResultsLength = (event: string[]) => {
                contentResultsLength.value = event.length;
              };
              const filterContent = (value: string) => {
                return optionsContent.value.filter((item: string) => {
                  return item.toLowerCase().startsWith(value.toLowerCase());
                });
              };
            </script>
          
        
    

Validation

Looks good!
Input value is required
        
            
            <template>
              <form
                class="needs-validation"
                novalidate
                @submit.prevent="checkForm"
              >
                <div id="validation" class="form-outline">
                  <MDBAutocomplete
                    v-model="autocompleteValidation"
                    :filter="filterValidation"
                    validFeedback="Looks good!"
                    invalidFeedback="Input value is required!"
                    required
                    label="Example label"
                  />
                </div>
                <MDBBtn color="primary" size="sm" class="mt-3" type="submit">
                  Submit
                </MDBBtn>
              </form>
            </template>
          
        
    
        
            
            <script>
              import { MDBAutocomplete, MDBBtn } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              export default {
                components: {
                  MDBAutocomplete, MDBBtn
                },
                setup() {
                  const autocompleteValidation = ref("");
                  const optionsValidation = ref([
                    "One",
                    "Two",
                    "Three",
                    "Four",
                    "Five",
                    "Six",
                    "Seven",
                    "Eight"
                  ]);
                  const filterValidation = value => {
                    return optionsValidation.value.filter(item => {
                      return item.toLowerCase().startsWith(value.toLowerCase());
                    });
                  };
                  const checkForm = event => {
                    event.target.classList.add("was-validated");
                  };

                  return {
                    autocompleteValidation,
                    filterValidation,
                    checkForm
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBAutocomplete, MDBBtn } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const autocompleteValidation = ref("");
              const optionsValidation = ref([
                "One",
                "Two",
                "Three",
                "Four",
                "Five",
                "Six",
                "Seven",
                "Eight"
              ]);
              const filterValidation = (value: string) => {
                return optionsValidation.value.filter((item: string) => {
                  return item.toLowerCase().startsWith(value.toLowerCase());
                });
              };
              const checkForm = (event: Event) => {
                (event.target as HTMLFormElement).classList.add("was-validated");
              };
            </script>
          
        
    

You can create custom rules and show the validation results via isValidated and isValid properties.

        
            
            <template>
              <MDBRow
                tag="form"
                class="g-3 needs-validation"
                novalidate
                @submit.prevent="checkFormPro"
              >
                <MDBCol col="12">
                  <MDBAutocomplete
                    v-model="autocompleteBasic"
                    :filter="filterBasic"
                    label="Example label"
                    :isValidated="isAutocompleteValidated"
                    :isValid="isAutocompleteValid"
                    validFeedback="This value is valid"
                    invalidFeedback="This value is invalid"
                    @update:model-value="validateAutocomplete"
                  />
                </MDBCol>
                <MDBCol col="12">
                  <MDBBtn color="primary" type="submit">Submit form</MDBBtn>
                </MDBCol>
              </MDBRow>
            </template>
          
        
    
        
            
            <script>
              import { MDBAutocomplete MDBBtn, MDBRow, MDBCol } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              export default {
                components: {
                  MDBSelect,
                  MDBBtn
                },
                setup() {
                  const autocompleteBasic = ref("");
                  const optionsBasic = ref([
                    "One",
                    "Two",
                    "Three",
                    "Four",
                    "Five",
                    "Six",
                    "Seven",
                    "Eight",
                  ]);
                  const filterBasic = (value: string) => {
                    return optionsBasic.value.filter((item: string) => {
                      return item.toLowerCase().startsWith(value.toLowerCase());
                    });
                  };

                  const isAutocompleteValidated = ref(false);
                  const isAutocompleteValid = ref(false);

                  const validateAutocomplete = () => {
                    if (!isAutocompleteValidated.value) {
                      return;
                    }
                    isAutocompleteValid.value =
                      optionsBasic.value.filter(
                        (v) =>
                          v.toLocaleLowerCase() === autocompleteBasic.value.toLocaleLowerCase()
                      ).length !== 0 && autocompleteBasic.value !== "";
                  };

                  const checkFormPro = (e) => {
                    e.target.classList.add("was-validated");
                    isAutocompleteValidated.value = true;
                    validateAutocomplete();
                  };

                  return {
                    autocompleteBasic,
                    optionsBasic,
                    filterBasic,
                    isAutocompleteValidated,
                    isAutocompleteValid,
                    validateAutocomplete,
                    checkFormPro
                  };
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBAutocomplete, MDBBtn, MDBRow, MDBCol } from "mdb-vue-ui-kit";
              import { ref } from "vue";

              const autocompleteBasic = ref("");
              const optionsBasic = ref([
                "One",
                "Two",
                "Three",
                "Four",
                "Five",
                "Six",
                "Seven",
                "Eight",
              ]);
              const filterBasic = (value: string) => {
                return optionsBasic.value.filter((item: string) => {
                  return item.toLowerCase().startsWith(value.toLowerCase());
                });
              };

              const isAutocompleteValidated = ref(false);
              const isAutocompleteValid = ref(false);

              const validateAutocomplete = () => {
                if (!isAutocompleteValidated.value) {
                  return;
                }
                isAutocompleteValid.value =
                  optionsBasic.value.filter(
                    (v) =>
                      v.toLocaleLowerCase() === autocompleteBasic.value.toLocaleLowerCase()
                  ).length !== 0 && autocompleteBasic.value !== "";
              };

              const checkFormPro = (e) => {
                e.target.classList.add("was-validated");
                isAutocompleteValidated.value = true;
                validateAutocomplete();
              };

            </script>
          
        
    

Auto select

Set autoSelect option to true to enable selecting on Tab press.

        
            
                <template>
                  <MDBAutocomplete v-model="autocompleteBasic" :filter="filterBasic" label="Example label" autoSelect />
                </template>
              
        
    
        
            
                <script>
                  import { MDBAutocomplete } from "mdb-vue-ui-kit";
                  import { ref } from "vue";

                  export default {
                    components: {
                      MDBAutocomplete
                    },
                    setup() {
                      const autocompleteBasic = ref("");
                      const optionsBasic = ref([
                        "One",
                        "Two",
                        "Three",
                        "Four",
                        "Five",
                      ]);
                      const filterBasic = value => {
                        return optionsBasic.value.filter(item => {
                          return item.toLowerCase().startsWith(value.toLowerCase());
                        });
                      };

                      return {
                        autocompleteBasic,
                        filterBasic
                      };
                    }
                  };
                </script>
              
        
    
        
            
                <script setup lang="ts">
                  import { MDBAutocomplete } from "mdb-vue-ui-kit";
                  import { ref } from "vue";

                  const autocompleteBasic = ref("");
                  const optionsBasic = ref([
                    "One",
                    "Two",
                    "Three",
                    "Four",
                    "Five",
                  ]);
                  const filterBasic = (value: string) => {
                    return optionsBasic.value.filter((item: string) => {
                      return item.toLowerCase().startsWith(value.toLowerCase());
                    });
                  };
                </script>
              
        
    

24H 00M 00S

Get one of the limited daily offers for AI Bundles with 98% OFF for our Black Days Sale!

Autocomplete - API


Import

        
            
          <script>
            import { MDBAutocomplete } from "mdb-vue-ui-kit";
          </script>
        
        
    

Properties

Property Type Default Description
autoSelect Boolean false Enables auto selecting on Tab press
filter Function - Function that returns filtered data to the component
keepOpen Boolean False Prevents the autocomplete popup from closing after value select and click outside
displayValue Function (value) => value Function executed for complex search results, to get value to display in the results list
filter Function - Function that returns filtered data to the component
itemContent Function - Function that returns custom template for result item
listHeight Number 190 Height of the result list
noResultsText String 'No results found' Message that will be displayed in the component dropdown if no result is found
threshold Number 300 Minimum input length to start search query
optionHeight Number 38 Set height for single item
visibleOptions Number 5 Set count of options visible without scroll

Methods

Name Description Example
open Manually opens a component dropdown $refs.autocompleteRef.open()
close Manually closes a component dropdown $refs.autocompleteRef.close()
toggle Manually toggles a component dropdown $refs.autocompleteRef.toggle()
        
            
        <template>
          <MDBBtn color="primary" @click="autocompleteRef?.open()"
            >Open autocomplete</MDBBtn
          >
          <MDBAutocomplete
            ref="autocompleteRef"
            v-model="autocompleteBasic"
            :filter="filterBasic"
            label="Example label"
          />
        </template>
        
        
    
        
            
        <script>
          import { MDBAutocomplete, MDBBtn } from "mdb-vue-ui-kit";
          import { ref } from "vue";
          
          export default {
            components: {
              MDBAutocomplete,
              MDBBtn,
            },
            setup() {
              const autocompleteRef = ref(null);
              const autocompleteBasic = ref("");
              const optionsBasic = ref([
                "One",
                "Two",
                "Three",
                "Four",
                "Five",
                "Six",
                "Seven",
                "Eight",
              ]);
              const filterBasic = (value) => {
                return optionsBasic.value.filter((item) => {
                  return item.toLowerCase().startsWith(value.toLowerCase());
                });
              };
          
              return {
                autocompleteBasic,
                filterBasic,
                autocompleteRef,
              };
            },
          };
          </script>
        
        
    
        
            
        <script setup lang="ts">
          import { MDBAutocomplete, MDBBtn } from "mdb-vue-ui-kit";
          import { ref } from "vue";
          
          const autocompleteRef = ref<InstanceType<typeof MDBAutocomplete> | null>(null);
          const autocompleteBasic = ref("");
          const optionsBasic = ref([
            "One",
            "Two",
            "Three",
            "Four",
            "Five",
            "Six",
            "Seven",
            "Eight",
          ]);
          const filterBasic = (value: string) => {
            return optionsBasic.value.filter((item) => {
              return item.toLowerCase().startsWith(value.toLowerCase());
            });
          };
          
        </script>
        
        
    

Slots

Name Description
default Slot for custom list content

Events

Name Description
open This event fires immediately when the autocomplete dropdown is opened.
close This event fires immediately when the autocomplete dropdown is closed.
itemSelect This event fires immediately when the autocomplete item is selected.
update This event fires immediately when the autocomplete results list is updated.
        
            
          <template>
            <MDBAutocomplete v-model="autocompleteBasic" :filter="filterBasic" label="Example label" @open="doSomething" />
          </tem>
        
        
    

CSS variables

        
            
          // .autocomplete-label
          --#{$prefix}autocomplete-label-max-width: #{$autocomplete-label-max-width};
          --#{$prefix}autocomplete-label-active-transform: #{$autocomplete-label-active-transform};
          --#{$prefix}autocomplete-label-color: #{$autocomplete-label-color};

          // .form-outline
          --#{$prefix}form-outline-select-notch-border-color: #{$form-outline-select-notch-border-color};

          // .autocomplete-input.focused
          --#{$prefix}autocomplete-input-focused-color: #{$autocomplete-input-focused-color};

          // .autocomplete-dropdown-container
          --#{$prefix}autocomplete-dropdown-container-zindex: #{$autocomplete-dropdown-container-zindex};
          --#{$prefix}autocomplete-dropdown-background-color: #{$autocomplete-dropdown-background-color};
          --#{$prefix}autocomplete-dropdown-box-shadow: #{$autocomplete-dropdown-box-shadow};
          --#{$prefix}autocomplete-dropdown-margin: #{$autocomplete-dropdown-margin};
          --#{$prefix}autocomplete-dropdown-transform: #{$autocomplete-dropdown-transform};
          --#{$prefix}autocomplete-dropdown-transition: #{$autocomplete-dropdown-transition};
          --#{$prefix}autocomplete-dropdown-open-transform: #{$autocomplete-dropdown-open-transform};
          --#{$prefix}autocomplete-item-color: #{$autocomplete-item-color};
          --#{$prefix}autocomplete-item-padding: #{$autocomplete-item-padding};
          --#{$prefix}autocomplete-item-font-size: #{$autocomplete-item-font-size};
          --#{$prefix}autocomplete-item-font-weight: #{$autocomplete-item-font-weight};
          --#{$prefix}autocomplete-item-hover-background-color: #{$autocomplete-item-hover-background-color};
          --#{$prefix}autocomplete-item-disabled-color: #{$autocomplete-item-disabled-color};
          --#{$prefix}autocomplete-scrollbar-thumb-background-color: #{$autocomplete-scrollbar-thumb-background-color};
        
        
    

SCSS variables

        
            
        $autocomplete-dropdown-container-zindex: 1065;

        $autocomplete-label-max-width: 80%;
        $autocomplete-label-active-transform: translateY(-1rem) translateY(0.1rem) scale(0.8);
        $autocomplete-input-focused-color: var(--#{$prefix}surface-color);
        $autocomplete-label-color: $primary;
        $autocomplete-dropdown-background-color: var(--#{$prefix}surface-bg);
        $autocomplete-dropdown-box-shadow: 0 2px 5px 0 rgba(var(--#{$prefix}box-shadow-color-rgb), 0.16), 0 2px 10px 0 rgba(var(--#{$prefix}box-shadow-color-rgb), 0.12);
        $autocomplete-dropdown-margin: 0;
        $autocomplete-dropdown-transform: scaleY(0.8);
        $autocomplete-dropdown-transition: all 0.2s;
        $autocomplete-dropdown-open-transform: scaleY(1);
        $autocomplete-item-color: var(--#{$prefix}surface-color);
        $autocomplete-item-padding: 6.5px 16px;
        $autocomplete-item-font-size: 1rem;
        $autocomplete-item-font-weight: 400;
        $autocomplete-item-hover-background-color: var(--#{$prefix}highlight-bg-color);
        $autocomplete-item-disabled-color: rgba(var(--#{$prefix}surface-color-rgb), 0.5);
        $autocomplete-scrollbar-thumb-background-color: var(--#{$prefix}scrollbar-thumb-bg);